posts - 297,  comments - 1618,  trackbacks - 0
    今天在导入一个工程时,编译并打包到Tomcat后,发现出现java.lang.UnsupportedClassVersionError: Bad version number in .class file异常,检查了一下我的myEclipse,发现不知道啥时候不小心将编译器改成JDK6.0了,那个工程是从同事的机上拷贝过来的,用的编译器是JDK5.0,试了一下,果然是这个问题引起。
    那次在Linux上部署工程时也出现过因为版本不同引起的问题,那时我们用的IDE的编译器是JDK5.0,而那台Linux装的是JDK6.0,部署后发现很多功能都出错,看来有些东西还是得注意一下啊。
    附,在myEclipse中改变编译器的方法:Project->Properties->Java Compiler->Configure Workspace Setting,在弹出的页面中可以进行设置。
    大家可以参考一下这篇文章:java 1.5 和 1.6环境共存的时候发现的错误
posted on 2007-10-23 09:09 阿蜜果 阅读(111967) 评论(54)  编辑  收藏 所属分类: Java


FeedBack:
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2007-12-22 12:34 | Hellen
谢谢!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2008-03-26 09:55 | kelly
3Q  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-04-18 19:16 | d
xie  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2008-04-24 00:23 | eric
thx  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-05-15 21:57 | Java GreenHand
Thank you very very much!!!!!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-06-02 15:41 | awin
谢谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-06-12 17:30 | alloyer
非常感谢   回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-06-13 10:13 | yn
xiexie  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-08-11 09:51 | weixiangerdou
非常感谢!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-08-22 11:07 | sutf
太感激你了!!!!!!!!!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-09-04 18:25 | xjl
谢谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-10-14 17:44 | fangaiyun
非常感谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2008-11-18 06:47 | 王音
谢谢了!多亏了你的解释!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2008-12-10 13:15 | 哈哈
3Q 这个问题困扰我好久,今天解决了。谢谢哈。。  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-03-02 11:32 | ws
3q  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-03-03 15:31 | 潘顺昌
楼主,你的问题Bad version number in .class file

跟jdk有关,没错,但是你没有找到本质所在!我今天也遇到这个问题!

请教了别人,网上找了资料,最后确定是由于 使用了对象类型跟基本型别做比较造成的,比如: Double s = Double.valueOf("3") , int i = 1;

if(s>i){}
这样的语言,jdk6是可以正常编译的,但是在低版本的jdk,就会出现
Bad version number in .class file错误,如果把改为 if(s.doubleValue()>i)
转型一下,就可以了,jdk可以使用低些版本也没问题  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-05-15 15:33 | a
谢谢!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-05-27 11:42 | devin
thanks  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-06-05 01:01 | 腾飞
非常非常感谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-06-07 00:52 | dd
xx  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-06-07 23:36 | 老刘
太谢谢你了 , 支持你 !!!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-07-04 01:07 | deng
xieixe  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-07-24 14:07 | supreme
谢谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-10-15 10:53 | tan
很有钻牛角尖的感觉,原理还不是一样的吗?  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2009-10-15 10:54 | tan
@潘顺昌
  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-11-21 20:34 | geek87
很好很强大  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-11-23 10:33 | happy
eclipse的preferences>Installed JREs里面添加一个jre6并且勾选中是使用该jre就好了  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2009-12-08 21:47 | 愛是唯一
謝謝,讓我順利解決問題。  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2010-01-08 09:17 | 张慧敏
真是太感谢了 顺利解决了问题  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2010-03-18 13:49 | yongbin
THX  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2010-05-17 18:06 | xiaofei-suman
谢谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2010-06-02 11:39 | administrator
谢谢!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2010-09-13 12:25 | tang
学习了
  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-02-20 20:37 | value
thanks......  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-07-20 11:17 | 董士亮
好用  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-08-22 12:00 | GavinMiao
刚好用上,谢谢分享!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2011-11-01 14:16 | 啊啊
问题是我该了还是在启动weblogic时报这个错  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2011-11-01 22:29 | haha
也遇到了这个问题
使用的是myeclipse ,server里配置的tomcat
修改了tomcat的 的jdk 选项 使用自己安装的jdk 问题就解决了。

eclipse的preferences>Installed JREs里面添加 自己安装的jdk  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-11-02 15:36 | 谢谢
谢谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2011-11-27 21:45 | hanwei
不行,解决不了问题
  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-11-28 21:09 | stylr
根本原因是 新建项目所选的 JDK 版本和 Tomcat 所使用的编译版本 不一致。
因为 很有可能 我们使用的是MyEclipse 开发 而 Tomcat 所选的JDk 默认是 MyEclipse 自带的 ,目前使用最多的 MyEclipse 的 版本是 6.5 左右的(最新版本是10)。MyEclipse 自带的 JDK 版本过低。

解决办法是 将 Tomcat 的 JDK 版本设置成 自己新建项目JDK 版本一致 就行。  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-12-03 15:23 | 邹华龙
按照解决方法步骤进行了调试,不行啊  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-12-08 14:34 | yan ping
谢谢楼主  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2011-12-08 14:36 | yan ping
我遇到这样的问题用楼主的方法解决了,谢谢楼主  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2012-03-19 11:49 |
纠结了好长时间 终于解决了 谢谢楼主  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2012-04-27 11:18 | fy
我有一个项目 myeclipse 中 compiler 换成5.0 running jre 换成 jdk1.5 就能启动了。
而用compiler 6.0 running jre jdk1.6 启动就报错。   回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2012-04-27 11:19 | fy
compiler 换成5.0 ,running jre 换成 jdk1.5   回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2012-06-15 09:34 | UnsupportedClassVersionError
明白了 , 问题也解决了 ,跪谢  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2012-09-28 16:59 | xxx
thx  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2013-06-04 16:47 | ls
问题的根本原因是运行环境与编译环境不一致造成的,至于解决方法需要看具体问题,比如:整个工程用1.5编译,1.6运行。那么只需要把运行环境切换到1.6上,或者用1.5从新编译即可。还有些情况是由于第三方jar包只支持1.6运行,遇到这种情况需要更换jar包到更早的版本(commons-dbcp-1.4.jar只支持1.6的运行环境,如果放在1.5下运行就会出现楼主的错误,当替换为commons.dbcp.1.2.2.jar后在1.5下则运行正常)。  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2014-08-28 10:38 | 一堣而安
非常感谢,找了好久咯。

补充一下,要重启myeclipse 才生效咯。  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file[未登录]
2015-08-20 16:27 | 张三
太感谢了!!!  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2016-01-05 16:25 | brose
非常感谢,碰到了同样的问题  回复  更多评论
  
# re: 异常备忘:java.lang.UnsupportedClassVersionError: Bad version number in .class file
2016-01-05 16:26 | brose
不过换成1.6,还是没有解决
java.lang.UnsupportedClassVersionError: Bad version number in .class file
at java.lang.ClassLoader.defineClass1(Native Method)
at java.lang.ClassLoader.defineClass(Unknown Source)
at org.eclipse.osgi.internal.baseadaptor.DefaultClassLoader.defineClass(DefaultClassLoader.java:188)
at org.eclipse.osgi.baseadaptor.loader.ClasspathManager.defineClass(ClasspathManager.java:580)
at org.eclipse.osgi.baseadaptor.loader.ClasspathManager.findClassImpl(ClasspathManager.java:550)
at org.eclipse.osgi.baseadaptor.loader.ClasspathManager.findLocalClassImpl(ClasspathManager.java:481)
at org.eclipse.osgi.baseadaptor.loader.ClasspathManager.findLocalClass_LockClassLoader(ClasspathManager.java:469)
at org.eclipse.osgi.baseadaptor.loader.ClasspathManager.findLocalClass(ClasspathManager.java:449)
at org.eclipse.osgi.internal.baseadaptor.DefaultClassLoader.findLocalClass(DefaultClassLoader.java:216)
at org.eclipse.osgi.internal.loader.BundleLoader.findLocalClass(BundleLoader.java:393)
at org.eclipse.osgi.internal.loader.BundleLoader.findClassInternal(BundleLoader.java:469)

  回复  更多评论
  

只有注册用户登录后才能发表评论。


网站导航:
 
<2007年10月>
30123456
78910111213
14151617181920
21222324252627
28293031123
45678910

      生活将我们磨圆,是为了让我们滚得更远——“圆”来如此。
      我的作品:
      玩转Axure RP  (2015年12月出版)
      

      Power Designer系统分析与建模实战  (2015年7月出版)
      
     Struts2+Hibernate3+Spring2   (2010年5月出版)
     

留言簿(254)

随笔分类

随笔档案

文章分类

相册

关注blog

积分与排名

  • 积分 - 2128977
  • 排名 - 3

最新评论

阅读排行榜

评论排行榜